#ifndef MULTIOBJECTIVE_KERNEL

#define MULTIOBJECTIVE_KERNEL

typedef struct PARETOFRONT {
	int Max_no_Solution;

	int no_Dimension;
	int no_Function;

	int no_ParetoFront_Solution;

	double **ParetoFront_Solution;
	double **ParetoFront_Fitness;
	int *ParetoFront_Rank;

	double IGD;

} ParetoFront;

void ParetoFront_Info_Construction(ParetoFront*, int, int, int);
void ParetoFront_Info_Destruction(ParetoFront);
void ParetoFront_Info_Expansion(ParetoFront*, int);

void ParetoFront_Construction(ParetoFront*, int*);
void ParetoFront_OptimalConstruction(ParetoFront*, int*);
void ParetoFrontTruncation(ParetoFront*, int);
void ParetoFront_Save(ParetoFront, FILE*, int);

void ParetoFront_IGD(ParetoFront*,ParetoFront);

void ParetoFront_Testing();

#endif

